package br.mp.mprj.portal.portlet.gestaomensagens.service.service.persistence;

import br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException;
import br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem;
import br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemImpl;
import br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl;
import br.mp.mprj.portal.portlet.gestaomensagens.service.service.persistence.AnexoMensagemPersistence;

import com.liferay.portal.kernel.cache.CacheRegistryUtil;
import com.liferay.portal.kernel.dao.orm.EntityCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderCacheUtil;
import com.liferay.portal.kernel.dao.orm.FinderPath;
import com.liferay.portal.kernel.dao.orm.Query;
import com.liferay.portal.kernel.dao.orm.QueryPos;
import com.liferay.portal.kernel.dao.orm.QueryUtil;
import com.liferay.portal.kernel.dao.orm.Session;
import com.liferay.portal.kernel.exception.SystemException;
import com.liferay.portal.kernel.log.Log;
import com.liferay.portal.kernel.log.LogFactoryUtil;
import com.liferay.portal.kernel.util.GetterUtil;
import com.liferay.portal.kernel.util.InstanceFactory;
import com.liferay.portal.kernel.util.OrderByComparator;
import com.liferay.portal.kernel.util.PropsKeys;
import com.liferay.portal.kernel.util.PropsUtil;
import com.liferay.portal.kernel.util.SetUtil;
import com.liferay.portal.kernel.util.StringBundler;
import com.liferay.portal.kernel.util.StringPool;
import com.liferay.portal.kernel.util.StringUtil;
import com.liferay.portal.kernel.util.UnmodifiableList;
import com.liferay.portal.kernel.util.Validator;
import com.liferay.portal.kernel.uuid.PortalUUIDUtil;
import com.liferay.portal.model.CacheModel;
import com.liferay.portal.model.ModelListener;
import com.liferay.portal.service.persistence.impl.BasePersistenceImpl;

import java.io.Serializable;

import java.util.ArrayList;
import java.util.Collections;
import java.util.List;
import java.util.Set;

/**
 * The persistence implementation for the anexo mensagem service.
 *
 * <p>
 * Caching information and settings can be found in <code>portal.properties</code>
 * </p>
 *
 * @author Henrique Simoes
 * @see AnexoMensagemPersistence
 * @see AnexoMensagemUtil
 * @generated
 */
public class AnexoMensagemPersistenceImpl extends BasePersistenceImpl<AnexoMensagem>
    implements AnexoMensagemPersistence {
    /*
     * NOTE FOR DEVELOPERS:
     *
     * Never modify or reference this class directly. Always use {@link AnexoMensagemUtil} to access the anexo mensagem persistence. Modify <code>service.xml</code> and rerun ServiceBuilder to regenerate this class.
     */
    public static final String FINDER_CLASS_NAME_ENTITY = AnexoMensagemImpl.class.getName();
    public static final String FINDER_CLASS_NAME_LIST_WITH_PAGINATION = FINDER_CLASS_NAME_ENTITY +
        ".List1";
    public static final String FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION = FINDER_CLASS_NAME_ENTITY +
        ".List2";
    public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_ALL = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED,
            AnexoMensagemImpl.class, FINDER_CLASS_NAME_LIST_WITH_PAGINATION,
            "findAll", new String[0]);
    public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED,
            AnexoMensagemImpl.class, FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION,
            "findAll", new String[0]);
    public static final FinderPath FINDER_PATH_COUNT_ALL = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countAll", new String[0]);
    public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_UUID = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED,
            AnexoMensagemImpl.class, FINDER_CLASS_NAME_LIST_WITH_PAGINATION,
            "findByUuid",
            new String[] {
                String.class.getName(),
                
            Integer.class.getName(), Integer.class.getName(),
                OrderByComparator.class.getName()
            });
    public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED,
            AnexoMensagemImpl.class, FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION,
            "findByUuid", new String[] { String.class.getName() },
            AnexoMensagemModelImpl.UUID_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_UUID = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByUuid",
            new String[] { String.class.getName() });
    private static final String _FINDER_COLUMN_UUID_UUID_1 = "anexoMensagem.uuid IS NULL";
    private static final String _FINDER_COLUMN_UUID_UUID_2 = "anexoMensagem.uuid = ?";
    private static final String _FINDER_COLUMN_UUID_UUID_3 = "(anexoMensagem.uuid IS NULL OR anexoMensagem.uuid = '')";
    public static final FinderPath FINDER_PATH_FETCH_BY_UUID_G = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED,
            AnexoMensagemImpl.class, FINDER_CLASS_NAME_ENTITY, "fetchByUUID_G",
            new String[] { String.class.getName(), Long.class.getName() },
            AnexoMensagemModelImpl.UUID_COLUMN_BITMASK |
            AnexoMensagemModelImpl.GROUPID_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_UUID_G = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByUUID_G",
            new String[] { String.class.getName(), Long.class.getName() });
    private static final String _FINDER_COLUMN_UUID_G_UUID_1 = "anexoMensagem.uuid IS NULL AND ";
    private static final String _FINDER_COLUMN_UUID_G_UUID_2 = "anexoMensagem.uuid = ? AND ";
    private static final String _FINDER_COLUMN_UUID_G_UUID_3 = "(anexoMensagem.uuid IS NULL OR anexoMensagem.uuid = '') AND ";
    private static final String _FINDER_COLUMN_UUID_G_GROUPID_2 = "anexoMensagem.groupId = ?";
    public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_UUID_C = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED,
            AnexoMensagemImpl.class, FINDER_CLASS_NAME_LIST_WITH_PAGINATION,
            "findByUuid_C",
            new String[] {
                String.class.getName(), Long.class.getName(),
                
            Integer.class.getName(), Integer.class.getName(),
                OrderByComparator.class.getName()
            });
    public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C =
        new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED,
            AnexoMensagemImpl.class, FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION,
            "findByUuid_C",
            new String[] { String.class.getName(), Long.class.getName() },
            AnexoMensagemModelImpl.UUID_COLUMN_BITMASK |
            AnexoMensagemModelImpl.COMPANYID_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_UUID_C = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION, "countByUuid_C",
            new String[] { String.class.getName(), Long.class.getName() });
    private static final String _FINDER_COLUMN_UUID_C_UUID_1 = "anexoMensagem.uuid IS NULL AND ";
    private static final String _FINDER_COLUMN_UUID_C_UUID_2 = "anexoMensagem.uuid = ? AND ";
    private static final String _FINDER_COLUMN_UUID_C_UUID_3 = "(anexoMensagem.uuid IS NULL OR anexoMensagem.uuid = '') AND ";
    private static final String _FINDER_COLUMN_UUID_C_COMPANYID_2 = "anexoMensagem.companyId = ?";
    public static final FinderPath FINDER_PATH_WITH_PAGINATION_FIND_BY_MENSAGEMIDATIVO =
        new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED,
            AnexoMensagemImpl.class, FINDER_CLASS_NAME_LIST_WITH_PAGINATION,
            "findByMensagemIdAtivo",
            new String[] {
                Long.class.getName(), Boolean.class.getName(),
                
            Integer.class.getName(), Integer.class.getName(),
                OrderByComparator.class.getName()
            });
    public static final FinderPath FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_MENSAGEMIDATIVO =
        new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED,
            AnexoMensagemImpl.class, FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION,
            "findByMensagemIdAtivo",
            new String[] { Long.class.getName(), Boolean.class.getName() },
            AnexoMensagemModelImpl.MENSAGEMID_COLUMN_BITMASK |
            AnexoMensagemModelImpl.ATIVO_COLUMN_BITMASK);
    public static final FinderPath FINDER_PATH_COUNT_BY_MENSAGEMIDATIVO = new FinderPath(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemModelImpl.FINDER_CACHE_ENABLED, Long.class,
            FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION,
            "countByMensagemIdAtivo",
            new String[] { Long.class.getName(), Boolean.class.getName() });
    private static final String _FINDER_COLUMN_MENSAGEMIDATIVO_MENSAGEMID_2 = "anexoMensagem.mensagemId = ? AND ";
    private static final String _FINDER_COLUMN_MENSAGEMIDATIVO_ATIVO_2 = "anexoMensagem.ativo = ?";
    private static final String _SQL_SELECT_ANEXOMENSAGEM = "SELECT anexoMensagem FROM AnexoMensagem anexoMensagem";
    private static final String _SQL_SELECT_ANEXOMENSAGEM_WHERE = "SELECT anexoMensagem FROM AnexoMensagem anexoMensagem WHERE ";
    private static final String _SQL_COUNT_ANEXOMENSAGEM = "SELECT COUNT(anexoMensagem) FROM AnexoMensagem anexoMensagem";
    private static final String _SQL_COUNT_ANEXOMENSAGEM_WHERE = "SELECT COUNT(anexoMensagem) FROM AnexoMensagem anexoMensagem WHERE ";
    private static final String _ORDER_BY_ENTITY_ALIAS = "anexoMensagem.";
    private static final String _NO_SUCH_ENTITY_WITH_PRIMARY_KEY = "No AnexoMensagem exists with the primary key ";
    private static final String _NO_SUCH_ENTITY_WITH_KEY = "No AnexoMensagem exists with the key {";
    private static final boolean _HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE = GetterUtil.getBoolean(PropsUtil.get(
                PropsKeys.HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE));
    private static Log _log = LogFactoryUtil.getLog(AnexoMensagemPersistenceImpl.class);
    private static Set<String> _badColumnNames = SetUtil.fromArray(new String[] {
                "uuid"
            });
    private static AnexoMensagem _nullAnexoMensagem = new AnexoMensagemImpl() {
            @Override
            public Object clone() {
                return this;
            }

            @Override
            public CacheModel<AnexoMensagem> toCacheModel() {
                return _nullAnexoMensagemCacheModel;
            }
        };

    private static CacheModel<AnexoMensagem> _nullAnexoMensagemCacheModel = new CacheModel<AnexoMensagem>() {
            @Override
            public AnexoMensagem toEntityModel() {
                return _nullAnexoMensagem;
            }
        };

    public AnexoMensagemPersistenceImpl() {
        setModelClass(AnexoMensagem.class);
    }

    /**
     * Returns all the anexo mensagems where uuid = &#63;.
     *
     * @param uuid the uuid
     * @return the matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findByUuid(String uuid)
        throws SystemException {
        return findByUuid(uuid, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
    }

    /**
     * Returns a range of all the anexo mensagems where uuid = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param uuid the uuid
     * @param start the lower bound of the range of anexo mensagems
     * @param end the upper bound of the range of anexo mensagems (not inclusive)
     * @return the range of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findByUuid(String uuid, int start, int end)
        throws SystemException {
        return findByUuid(uuid, start, end, null);
    }

    /**
     * Returns an ordered range of all the anexo mensagems where uuid = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param uuid the uuid
     * @param start the lower bound of the range of anexo mensagems
     * @param end the upper bound of the range of anexo mensagems (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findByUuid(String uuid, int start, int end,
        OrderByComparator orderByComparator) throws SystemException {
        boolean pagination = true;
        FinderPath finderPath = null;
        Object[] finderArgs = null;

        if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
                (orderByComparator == null)) {
            pagination = false;
            finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID;
            finderArgs = new Object[] { uuid };
        } else {
            finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_UUID;
            finderArgs = new Object[] { uuid, start, end, orderByComparator };
        }

        List<AnexoMensagem> list = (List<AnexoMensagem>) FinderCacheUtil.getResult(finderPath,
                finderArgs, this);

        if ((list != null) && !list.isEmpty()) {
            for (AnexoMensagem anexoMensagem : list) {
                if (!Validator.equals(uuid, anexoMensagem.getUuid())) {
                    list = null;

                    break;
                }
            }
        }

        if (list == null) {
            StringBundler query = null;

            if (orderByComparator != null) {
                query = new StringBundler(3 +
                        (orderByComparator.getOrderByFields().length * 3));
            } else {
                query = new StringBundler(3);
            }

            query.append(_SQL_SELECT_ANEXOMENSAGEM_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_UUID_2);
            }

            if (orderByComparator != null) {
                appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
                    orderByComparator);
            } else
             if (pagination) {
                query.append(AnexoMensagemModelImpl.ORDER_BY_JPQL);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                if (!pagination) {
                    list = (List<AnexoMensagem>) QueryUtil.list(q,
                            getDialect(), start, end, false);

                    Collections.sort(list);

                    list = new UnmodifiableList<AnexoMensagem>(list);
                } else {
                    list = (List<AnexoMensagem>) QueryUtil.list(q,
                            getDialect(), start, end);
                }

                cacheResult(list);

                FinderCacheUtil.putResult(finderPath, finderArgs, list);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return list;
    }

    /**
     * Returns the first anexo mensagem in the ordered set where uuid = &#63;.
     *
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem findByUuid_First(String uuid,
        OrderByComparator orderByComparator)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = fetchByUuid_First(uuid, orderByComparator);

        if (anexoMensagem != null) {
            return anexoMensagem;
        }

        StringBundler msg = new StringBundler(4);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("uuid=");
        msg.append(uuid);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchAnexoMensagemException(msg.toString());
    }

    /**
     * Returns the first anexo mensagem in the ordered set where uuid = &#63;.
     *
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByUuid_First(String uuid,
        OrderByComparator orderByComparator) throws SystemException {
        List<AnexoMensagem> list = findByUuid(uuid, 0, 1, orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the last anexo mensagem in the ordered set where uuid = &#63;.
     *
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem findByUuid_Last(String uuid,
        OrderByComparator orderByComparator)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = fetchByUuid_Last(uuid, orderByComparator);

        if (anexoMensagem != null) {
            return anexoMensagem;
        }

        StringBundler msg = new StringBundler(4);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("uuid=");
        msg.append(uuid);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchAnexoMensagemException(msg.toString());
    }

    /**
     * Returns the last anexo mensagem in the ordered set where uuid = &#63;.
     *
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByUuid_Last(String uuid,
        OrderByComparator orderByComparator) throws SystemException {
        int count = countByUuid(uuid);

        if (count == 0) {
            return null;
        }

        List<AnexoMensagem> list = findByUuid(uuid, count - 1, count,
                orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the anexo mensagems before and after the current anexo mensagem in the ordered set where uuid = &#63;.
     *
     * @param anexoMensagemId the primary key of the current anexo mensagem
     * @param uuid the uuid
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the previous, current, and next anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem[] findByUuid_PrevAndNext(long anexoMensagemId,
        String uuid, OrderByComparator orderByComparator)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = findByPrimaryKey(anexoMensagemId);

        Session session = null;

        try {
            session = openSession();

            AnexoMensagem[] array = new AnexoMensagemImpl[3];

            array[0] = getByUuid_PrevAndNext(session, anexoMensagem, uuid,
                    orderByComparator, true);

            array[1] = anexoMensagem;

            array[2] = getByUuid_PrevAndNext(session, anexoMensagem, uuid,
                    orderByComparator, false);

            return array;
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }
    }

    protected AnexoMensagem getByUuid_PrevAndNext(Session session,
        AnexoMensagem anexoMensagem, String uuid,
        OrderByComparator orderByComparator, boolean previous) {
        StringBundler query = null;

        if (orderByComparator != null) {
            query = new StringBundler(6 +
                    (orderByComparator.getOrderByFields().length * 6));
        } else {
            query = new StringBundler(3);
        }

        query.append(_SQL_SELECT_ANEXOMENSAGEM_WHERE);

        boolean bindUuid = false;

        if (uuid == null) {
            query.append(_FINDER_COLUMN_UUID_UUID_1);
        } else if (uuid.equals(StringPool.BLANK)) {
            query.append(_FINDER_COLUMN_UUID_UUID_3);
        } else {
            bindUuid = true;

            query.append(_FINDER_COLUMN_UUID_UUID_2);
        }

        if (orderByComparator != null) {
            String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

            if (orderByConditionFields.length > 0) {
                query.append(WHERE_AND);
            }

            for (int i = 0; i < orderByConditionFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByConditionFields[i]);

                if ((i + 1) < orderByConditionFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN_HAS_NEXT);
                    } else {
                        query.append(WHERE_LESSER_THAN_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN);
                    } else {
                        query.append(WHERE_LESSER_THAN);
                    }
                }
            }

            query.append(ORDER_BY_CLAUSE);

            String[] orderByFields = orderByComparator.getOrderByFields();

            for (int i = 0; i < orderByFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByFields[i]);

                if ((i + 1) < orderByFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC_HAS_NEXT);
                    } else {
                        query.append(ORDER_BY_DESC_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC);
                    } else {
                        query.append(ORDER_BY_DESC);
                    }
                }
            }
        } else {
            query.append(AnexoMensagemModelImpl.ORDER_BY_JPQL);
        }

        String sql = query.toString();

        Query q = session.createQuery(sql);

        q.setFirstResult(0);
        q.setMaxResults(2);

        QueryPos qPos = QueryPos.getInstance(q);

        if (bindUuid) {
            qPos.add(uuid);
        }

        if (orderByComparator != null) {
            Object[] values = orderByComparator.getOrderByConditionValues(anexoMensagem);

            for (Object value : values) {
                qPos.add(value);
            }
        }

        List<AnexoMensagem> list = q.list();

        if (list.size() == 2) {
            return list.get(1);
        } else {
            return null;
        }
    }

    /**
     * Removes all the anexo mensagems where uuid = &#63; from the database.
     *
     * @param uuid the uuid
     * @throws SystemException if a system exception occurred
     */
    @Override
    public void removeByUuid(String uuid) throws SystemException {
        for (AnexoMensagem anexoMensagem : findByUuid(uuid, QueryUtil.ALL_POS,
                QueryUtil.ALL_POS, null)) {
            remove(anexoMensagem);
        }
    }

    /**
     * Returns the number of anexo mensagems where uuid = &#63;.
     *
     * @param uuid the uuid
     * @return the number of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByUuid(String uuid) throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_UUID;

        Object[] finderArgs = new Object[] { uuid };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(2);

            query.append(_SQL_COUNT_ANEXOMENSAGEM_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_UUID_2);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Returns the anexo mensagem where uuid = &#63; and groupId = &#63; or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException} if it could not be found.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @return the matching anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem findByUUID_G(String uuid, long groupId)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = fetchByUUID_G(uuid, groupId);

        if (anexoMensagem == null) {
            StringBundler msg = new StringBundler(6);

            msg.append(_NO_SUCH_ENTITY_WITH_KEY);

            msg.append("uuid=");
            msg.append(uuid);

            msg.append(", groupId=");
            msg.append(groupId);

            msg.append(StringPool.CLOSE_CURLY_BRACE);

            if (_log.isWarnEnabled()) {
                _log.warn(msg.toString());
            }

            throw new NoSuchAnexoMensagemException(msg.toString());
        }

        return anexoMensagem;
    }

    /**
     * Returns the anexo mensagem where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found. Uses the finder cache.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @return the matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByUUID_G(String uuid, long groupId)
        throws SystemException {
        return fetchByUUID_G(uuid, groupId, true);
    }

    /**
     * Returns the anexo mensagem where uuid = &#63; and groupId = &#63; or returns <code>null</code> if it could not be found, optionally using the finder cache.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @param retrieveFromCache whether to use the finder cache
     * @return the matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByUUID_G(String uuid, long groupId,
        boolean retrieveFromCache) throws SystemException {
        Object[] finderArgs = new Object[] { uuid, groupId };

        Object result = null;

        if (retrieveFromCache) {
            result = FinderCacheUtil.getResult(FINDER_PATH_FETCH_BY_UUID_G,
                    finderArgs, this);
        }

        if (result instanceof AnexoMensagem) {
            AnexoMensagem anexoMensagem = (AnexoMensagem) result;

            if (!Validator.equals(uuid, anexoMensagem.getUuid()) ||
                    (groupId != anexoMensagem.getGroupId())) {
                result = null;
            }
        }

        if (result == null) {
            StringBundler query = new StringBundler(4);

            query.append(_SQL_SELECT_ANEXOMENSAGEM_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_G_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_G_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_G_UUID_2);
            }

            query.append(_FINDER_COLUMN_UUID_G_GROUPID_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                qPos.add(groupId);

                List<AnexoMensagem> list = q.list();

                if (list.isEmpty()) {
                    FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G,
                        finderArgs, list);
                } else {
                    AnexoMensagem anexoMensagem = list.get(0);

                    result = anexoMensagem;

                    cacheResult(anexoMensagem);

                    if ((anexoMensagem.getUuid() == null) ||
                            !anexoMensagem.getUuid().equals(uuid) ||
                            (anexoMensagem.getGroupId() != groupId)) {
                        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G,
                            finderArgs, anexoMensagem);
                    }
                }
            } catch (Exception e) {
                FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_UUID_G,
                    finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        if (result instanceof List<?>) {
            return null;
        } else {
            return (AnexoMensagem) result;
        }
    }

    /**
     * Removes the anexo mensagem where uuid = &#63; and groupId = &#63; from the database.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @return the anexo mensagem that was removed
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem removeByUUID_G(String uuid, long groupId)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = findByUUID_G(uuid, groupId);

        return remove(anexoMensagem);
    }

    /**
     * Returns the number of anexo mensagems where uuid = &#63; and groupId = &#63;.
     *
     * @param uuid the uuid
     * @param groupId the group ID
     * @return the number of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByUUID_G(String uuid, long groupId)
        throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_UUID_G;

        Object[] finderArgs = new Object[] { uuid, groupId };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(3);

            query.append(_SQL_COUNT_ANEXOMENSAGEM_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_G_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_G_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_G_UUID_2);
            }

            query.append(_FINDER_COLUMN_UUID_G_GROUPID_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                qPos.add(groupId);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Returns all the anexo mensagems where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @return the matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findByUuid_C(String uuid, long companyId)
        throws SystemException {
        return findByUuid_C(uuid, companyId, QueryUtil.ALL_POS,
            QueryUtil.ALL_POS, null);
    }

    /**
     * Returns a range of all the anexo mensagems where uuid = &#63; and companyId = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param start the lower bound of the range of anexo mensagems
     * @param end the upper bound of the range of anexo mensagems (not inclusive)
     * @return the range of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findByUuid_C(String uuid, long companyId,
        int start, int end) throws SystemException {
        return findByUuid_C(uuid, companyId, start, end, null);
    }

    /**
     * Returns an ordered range of all the anexo mensagems where uuid = &#63; and companyId = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param start the lower bound of the range of anexo mensagems
     * @param end the upper bound of the range of anexo mensagems (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findByUuid_C(String uuid, long companyId,
        int start, int end, OrderByComparator orderByComparator)
        throws SystemException {
        boolean pagination = true;
        FinderPath finderPath = null;
        Object[] finderArgs = null;

        if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
                (orderByComparator == null)) {
            pagination = false;
            finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C;
            finderArgs = new Object[] { uuid, companyId };
        } else {
            finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_UUID_C;
            finderArgs = new Object[] {
                    uuid, companyId,
                    
                    start, end, orderByComparator
                };
        }

        List<AnexoMensagem> list = (List<AnexoMensagem>) FinderCacheUtil.getResult(finderPath,
                finderArgs, this);

        if ((list != null) && !list.isEmpty()) {
            for (AnexoMensagem anexoMensagem : list) {
                if (!Validator.equals(uuid, anexoMensagem.getUuid()) ||
                        (companyId != anexoMensagem.getCompanyId())) {
                    list = null;

                    break;
                }
            }
        }

        if (list == null) {
            StringBundler query = null;

            if (orderByComparator != null) {
                query = new StringBundler(4 +
                        (orderByComparator.getOrderByFields().length * 3));
            } else {
                query = new StringBundler(4);
            }

            query.append(_SQL_SELECT_ANEXOMENSAGEM_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_C_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_C_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_C_UUID_2);
            }

            query.append(_FINDER_COLUMN_UUID_C_COMPANYID_2);

            if (orderByComparator != null) {
                appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
                    orderByComparator);
            } else
             if (pagination) {
                query.append(AnexoMensagemModelImpl.ORDER_BY_JPQL);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                qPos.add(companyId);

                if (!pagination) {
                    list = (List<AnexoMensagem>) QueryUtil.list(q,
                            getDialect(), start, end, false);

                    Collections.sort(list);

                    list = new UnmodifiableList<AnexoMensagem>(list);
                } else {
                    list = (List<AnexoMensagem>) QueryUtil.list(q,
                            getDialect(), start, end);
                }

                cacheResult(list);

                FinderCacheUtil.putResult(finderPath, finderArgs, list);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return list;
    }

    /**
     * Returns the first anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem findByUuid_C_First(String uuid, long companyId,
        OrderByComparator orderByComparator)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = fetchByUuid_C_First(uuid, companyId,
                orderByComparator);

        if (anexoMensagem != null) {
            return anexoMensagem;
        }

        StringBundler msg = new StringBundler(6);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("uuid=");
        msg.append(uuid);

        msg.append(", companyId=");
        msg.append(companyId);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchAnexoMensagemException(msg.toString());
    }

    /**
     * Returns the first anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByUuid_C_First(String uuid, long companyId,
        OrderByComparator orderByComparator) throws SystemException {
        List<AnexoMensagem> list = findByUuid_C(uuid, companyId, 0, 1,
                orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the last anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem findByUuid_C_Last(String uuid, long companyId,
        OrderByComparator orderByComparator)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = fetchByUuid_C_Last(uuid, companyId,
                orderByComparator);

        if (anexoMensagem != null) {
            return anexoMensagem;
        }

        StringBundler msg = new StringBundler(6);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("uuid=");
        msg.append(uuid);

        msg.append(", companyId=");
        msg.append(companyId);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchAnexoMensagemException(msg.toString());
    }

    /**
     * Returns the last anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByUuid_C_Last(String uuid, long companyId,
        OrderByComparator orderByComparator) throws SystemException {
        int count = countByUuid_C(uuid, companyId);

        if (count == 0) {
            return null;
        }

        List<AnexoMensagem> list = findByUuid_C(uuid, companyId, count - 1,
                count, orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the anexo mensagems before and after the current anexo mensagem in the ordered set where uuid = &#63; and companyId = &#63;.
     *
     * @param anexoMensagemId the primary key of the current anexo mensagem
     * @param uuid the uuid
     * @param companyId the company ID
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the previous, current, and next anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem[] findByUuid_C_PrevAndNext(long anexoMensagemId,
        String uuid, long companyId, OrderByComparator orderByComparator)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = findByPrimaryKey(anexoMensagemId);

        Session session = null;

        try {
            session = openSession();

            AnexoMensagem[] array = new AnexoMensagemImpl[3];

            array[0] = getByUuid_C_PrevAndNext(session, anexoMensagem, uuid,
                    companyId, orderByComparator, true);

            array[1] = anexoMensagem;

            array[2] = getByUuid_C_PrevAndNext(session, anexoMensagem, uuid,
                    companyId, orderByComparator, false);

            return array;
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }
    }

    protected AnexoMensagem getByUuid_C_PrevAndNext(Session session,
        AnexoMensagem anexoMensagem, String uuid, long companyId,
        OrderByComparator orderByComparator, boolean previous) {
        StringBundler query = null;

        if (orderByComparator != null) {
            query = new StringBundler(6 +
                    (orderByComparator.getOrderByFields().length * 6));
        } else {
            query = new StringBundler(3);
        }

        query.append(_SQL_SELECT_ANEXOMENSAGEM_WHERE);

        boolean bindUuid = false;

        if (uuid == null) {
            query.append(_FINDER_COLUMN_UUID_C_UUID_1);
        } else if (uuid.equals(StringPool.BLANK)) {
            query.append(_FINDER_COLUMN_UUID_C_UUID_3);
        } else {
            bindUuid = true;

            query.append(_FINDER_COLUMN_UUID_C_UUID_2);
        }

        query.append(_FINDER_COLUMN_UUID_C_COMPANYID_2);

        if (orderByComparator != null) {
            String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

            if (orderByConditionFields.length > 0) {
                query.append(WHERE_AND);
            }

            for (int i = 0; i < orderByConditionFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByConditionFields[i]);

                if ((i + 1) < orderByConditionFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN_HAS_NEXT);
                    } else {
                        query.append(WHERE_LESSER_THAN_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN);
                    } else {
                        query.append(WHERE_LESSER_THAN);
                    }
                }
            }

            query.append(ORDER_BY_CLAUSE);

            String[] orderByFields = orderByComparator.getOrderByFields();

            for (int i = 0; i < orderByFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByFields[i]);

                if ((i + 1) < orderByFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC_HAS_NEXT);
                    } else {
                        query.append(ORDER_BY_DESC_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC);
                    } else {
                        query.append(ORDER_BY_DESC);
                    }
                }
            }
        } else {
            query.append(AnexoMensagemModelImpl.ORDER_BY_JPQL);
        }

        String sql = query.toString();

        Query q = session.createQuery(sql);

        q.setFirstResult(0);
        q.setMaxResults(2);

        QueryPos qPos = QueryPos.getInstance(q);

        if (bindUuid) {
            qPos.add(uuid);
        }

        qPos.add(companyId);

        if (orderByComparator != null) {
            Object[] values = orderByComparator.getOrderByConditionValues(anexoMensagem);

            for (Object value : values) {
                qPos.add(value);
            }
        }

        List<AnexoMensagem> list = q.list();

        if (list.size() == 2) {
            return list.get(1);
        } else {
            return null;
        }
    }

    /**
     * Removes all the anexo mensagems where uuid = &#63; and companyId = &#63; from the database.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @throws SystemException if a system exception occurred
     */
    @Override
    public void removeByUuid_C(String uuid, long companyId)
        throws SystemException {
        for (AnexoMensagem anexoMensagem : findByUuid_C(uuid, companyId,
                QueryUtil.ALL_POS, QueryUtil.ALL_POS, null)) {
            remove(anexoMensagem);
        }
    }

    /**
     * Returns the number of anexo mensagems where uuid = &#63; and companyId = &#63;.
     *
     * @param uuid the uuid
     * @param companyId the company ID
     * @return the number of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByUuid_C(String uuid, long companyId)
        throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_UUID_C;

        Object[] finderArgs = new Object[] { uuid, companyId };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(3);

            query.append(_SQL_COUNT_ANEXOMENSAGEM_WHERE);

            boolean bindUuid = false;

            if (uuid == null) {
                query.append(_FINDER_COLUMN_UUID_C_UUID_1);
            } else if (uuid.equals(StringPool.BLANK)) {
                query.append(_FINDER_COLUMN_UUID_C_UUID_3);
            } else {
                bindUuid = true;

                query.append(_FINDER_COLUMN_UUID_C_UUID_2);
            }

            query.append(_FINDER_COLUMN_UUID_C_COMPANYID_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                if (bindUuid) {
                    qPos.add(uuid);
                }

                qPos.add(companyId);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Returns all the anexo mensagems where mensagemId = &#63; and ativo = &#63;.
     *
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @return the matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findByMensagemIdAtivo(long mensagemId,
        boolean ativo) throws SystemException {
        return findByMensagemIdAtivo(mensagemId, ativo, QueryUtil.ALL_POS,
            QueryUtil.ALL_POS, null);
    }

    /**
     * Returns a range of all the anexo mensagems where mensagemId = &#63; and ativo = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @param start the lower bound of the range of anexo mensagems
     * @param end the upper bound of the range of anexo mensagems (not inclusive)
     * @return the range of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findByMensagemIdAtivo(long mensagemId,
        boolean ativo, int start, int end) throws SystemException {
        return findByMensagemIdAtivo(mensagemId, ativo, start, end, null);
    }

    /**
     * Returns an ordered range of all the anexo mensagems where mensagemId = &#63; and ativo = &#63;.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @param start the lower bound of the range of anexo mensagems
     * @param end the upper bound of the range of anexo mensagems (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findByMensagemIdAtivo(long mensagemId,
        boolean ativo, int start, int end, OrderByComparator orderByComparator)
        throws SystemException {
        boolean pagination = true;
        FinderPath finderPath = null;
        Object[] finderArgs = null;

        if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
                (orderByComparator == null)) {
            pagination = false;
            finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_MENSAGEMIDATIVO;
            finderArgs = new Object[] { mensagemId, ativo };
        } else {
            finderPath = FINDER_PATH_WITH_PAGINATION_FIND_BY_MENSAGEMIDATIVO;
            finderArgs = new Object[] {
                    mensagemId, ativo,
                    
                    start, end, orderByComparator
                };
        }

        List<AnexoMensagem> list = (List<AnexoMensagem>) FinderCacheUtil.getResult(finderPath,
                finderArgs, this);

        if ((list != null) && !list.isEmpty()) {
            for (AnexoMensagem anexoMensagem : list) {
                if ((mensagemId != anexoMensagem.getMensagemId()) ||
                        (ativo != anexoMensagem.getAtivo())) {
                    list = null;

                    break;
                }
            }
        }

        if (list == null) {
            StringBundler query = null;

            if (orderByComparator != null) {
                query = new StringBundler(4 +
                        (orderByComparator.getOrderByFields().length * 3));
            } else {
                query = new StringBundler(4);
            }

            query.append(_SQL_SELECT_ANEXOMENSAGEM_WHERE);

            query.append(_FINDER_COLUMN_MENSAGEMIDATIVO_MENSAGEMID_2);

            query.append(_FINDER_COLUMN_MENSAGEMIDATIVO_ATIVO_2);

            if (orderByComparator != null) {
                appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
                    orderByComparator);
            } else
             if (pagination) {
                query.append(AnexoMensagemModelImpl.ORDER_BY_JPQL);
            }

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                qPos.add(mensagemId);

                qPos.add(ativo);

                if (!pagination) {
                    list = (List<AnexoMensagem>) QueryUtil.list(q,
                            getDialect(), start, end, false);

                    Collections.sort(list);

                    list = new UnmodifiableList<AnexoMensagem>(list);
                } else {
                    list = (List<AnexoMensagem>) QueryUtil.list(q,
                            getDialect(), start, end);
                }

                cacheResult(list);

                FinderCacheUtil.putResult(finderPath, finderArgs, list);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return list;
    }

    /**
     * Returns the first anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
     *
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem findByMensagemIdAtivo_First(long mensagemId,
        boolean ativo, OrderByComparator orderByComparator)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = fetchByMensagemIdAtivo_First(mensagemId,
                ativo, orderByComparator);

        if (anexoMensagem != null) {
            return anexoMensagem;
        }

        StringBundler msg = new StringBundler(6);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("mensagemId=");
        msg.append(mensagemId);

        msg.append(", ativo=");
        msg.append(ativo);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchAnexoMensagemException(msg.toString());
    }

    /**
     * Returns the first anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
     *
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the first matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByMensagemIdAtivo_First(long mensagemId,
        boolean ativo, OrderByComparator orderByComparator)
        throws SystemException {
        List<AnexoMensagem> list = findByMensagemIdAtivo(mensagemId, ativo, 0,
                1, orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the last anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
     *
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem findByMensagemIdAtivo_Last(long mensagemId,
        boolean ativo, OrderByComparator orderByComparator)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = fetchByMensagemIdAtivo_Last(mensagemId,
                ativo, orderByComparator);

        if (anexoMensagem != null) {
            return anexoMensagem;
        }

        StringBundler msg = new StringBundler(6);

        msg.append(_NO_SUCH_ENTITY_WITH_KEY);

        msg.append("mensagemId=");
        msg.append(mensagemId);

        msg.append(", ativo=");
        msg.append(ativo);

        msg.append(StringPool.CLOSE_CURLY_BRACE);

        throw new NoSuchAnexoMensagemException(msg.toString());
    }

    /**
     * Returns the last anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
     *
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the last matching anexo mensagem, or <code>null</code> if a matching anexo mensagem could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByMensagemIdAtivo_Last(long mensagemId,
        boolean ativo, OrderByComparator orderByComparator)
        throws SystemException {
        int count = countByMensagemIdAtivo(mensagemId, ativo);

        if (count == 0) {
            return null;
        }

        List<AnexoMensagem> list = findByMensagemIdAtivo(mensagemId, ativo,
                count - 1, count, orderByComparator);

        if (!list.isEmpty()) {
            return list.get(0);
        }

        return null;
    }

    /**
     * Returns the anexo mensagems before and after the current anexo mensagem in the ordered set where mensagemId = &#63; and ativo = &#63;.
     *
     * @param anexoMensagemId the primary key of the current anexo mensagem
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @param orderByComparator the comparator to order the set by (optionally <code>null</code>)
     * @return the previous, current, and next anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem[] findByMensagemIdAtivo_PrevAndNext(
        long anexoMensagemId, long mensagemId, boolean ativo,
        OrderByComparator orderByComparator)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = findByPrimaryKey(anexoMensagemId);

        Session session = null;

        try {
            session = openSession();

            AnexoMensagem[] array = new AnexoMensagemImpl[3];

            array[0] = getByMensagemIdAtivo_PrevAndNext(session, anexoMensagem,
                    mensagemId, ativo, orderByComparator, true);

            array[1] = anexoMensagem;

            array[2] = getByMensagemIdAtivo_PrevAndNext(session, anexoMensagem,
                    mensagemId, ativo, orderByComparator, false);

            return array;
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }
    }

    protected AnexoMensagem getByMensagemIdAtivo_PrevAndNext(Session session,
        AnexoMensagem anexoMensagem, long mensagemId, boolean ativo,
        OrderByComparator orderByComparator, boolean previous) {
        StringBundler query = null;

        if (orderByComparator != null) {
            query = new StringBundler(6 +
                    (orderByComparator.getOrderByFields().length * 6));
        } else {
            query = new StringBundler(3);
        }

        query.append(_SQL_SELECT_ANEXOMENSAGEM_WHERE);

        query.append(_FINDER_COLUMN_MENSAGEMIDATIVO_MENSAGEMID_2);

        query.append(_FINDER_COLUMN_MENSAGEMIDATIVO_ATIVO_2);

        if (orderByComparator != null) {
            String[] orderByConditionFields = orderByComparator.getOrderByConditionFields();

            if (orderByConditionFields.length > 0) {
                query.append(WHERE_AND);
            }

            for (int i = 0; i < orderByConditionFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByConditionFields[i]);

                if ((i + 1) < orderByConditionFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN_HAS_NEXT);
                    } else {
                        query.append(WHERE_LESSER_THAN_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(WHERE_GREATER_THAN);
                    } else {
                        query.append(WHERE_LESSER_THAN);
                    }
                }
            }

            query.append(ORDER_BY_CLAUSE);

            String[] orderByFields = orderByComparator.getOrderByFields();

            for (int i = 0; i < orderByFields.length; i++) {
                query.append(_ORDER_BY_ENTITY_ALIAS);
                query.append(orderByFields[i]);

                if ((i + 1) < orderByFields.length) {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC_HAS_NEXT);
                    } else {
                        query.append(ORDER_BY_DESC_HAS_NEXT);
                    }
                } else {
                    if (orderByComparator.isAscending() ^ previous) {
                        query.append(ORDER_BY_ASC);
                    } else {
                        query.append(ORDER_BY_DESC);
                    }
                }
            }
        } else {
            query.append(AnexoMensagemModelImpl.ORDER_BY_JPQL);
        }

        String sql = query.toString();

        Query q = session.createQuery(sql);

        q.setFirstResult(0);
        q.setMaxResults(2);

        QueryPos qPos = QueryPos.getInstance(q);

        qPos.add(mensagemId);

        qPos.add(ativo);

        if (orderByComparator != null) {
            Object[] values = orderByComparator.getOrderByConditionValues(anexoMensagem);

            for (Object value : values) {
                qPos.add(value);
            }
        }

        List<AnexoMensagem> list = q.list();

        if (list.size() == 2) {
            return list.get(1);
        } else {
            return null;
        }
    }

    /**
     * Removes all the anexo mensagems where mensagemId = &#63; and ativo = &#63; from the database.
     *
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @throws SystemException if a system exception occurred
     */
    @Override
    public void removeByMensagemIdAtivo(long mensagemId, boolean ativo)
        throws SystemException {
        for (AnexoMensagem anexoMensagem : findByMensagemIdAtivo(mensagemId,
                ativo, QueryUtil.ALL_POS, QueryUtil.ALL_POS, null)) {
            remove(anexoMensagem);
        }
    }

    /**
     * Returns the number of anexo mensagems where mensagemId = &#63; and ativo = &#63;.
     *
     * @param mensagemId the mensagem ID
     * @param ativo the ativo
     * @return the number of matching anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countByMensagemIdAtivo(long mensagemId, boolean ativo)
        throws SystemException {
        FinderPath finderPath = FINDER_PATH_COUNT_BY_MENSAGEMIDATIVO;

        Object[] finderArgs = new Object[] { mensagemId, ativo };

        Long count = (Long) FinderCacheUtil.getResult(finderPath, finderArgs,
                this);

        if (count == null) {
            StringBundler query = new StringBundler(3);

            query.append(_SQL_COUNT_ANEXOMENSAGEM_WHERE);

            query.append(_FINDER_COLUMN_MENSAGEMIDATIVO_MENSAGEMID_2);

            query.append(_FINDER_COLUMN_MENSAGEMIDATIVO_ATIVO_2);

            String sql = query.toString();

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                QueryPos qPos = QueryPos.getInstance(q);

                qPos.add(mensagemId);

                qPos.add(ativo);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(finderPath, finderArgs, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    /**
     * Caches the anexo mensagem in the entity cache if it is enabled.
     *
     * @param anexoMensagem the anexo mensagem
     */
    @Override
    public void cacheResult(AnexoMensagem anexoMensagem) {
        EntityCacheUtil.putResult(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemImpl.class, anexoMensagem.getPrimaryKey(),
            anexoMensagem);

        FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G,
            new Object[] { anexoMensagem.getUuid(), anexoMensagem.getGroupId() },
            anexoMensagem);

        anexoMensagem.resetOriginalValues();
    }

    /**
     * Caches the anexo mensagems in the entity cache if it is enabled.
     *
     * @param anexoMensagems the anexo mensagems
     */
    @Override
    public void cacheResult(List<AnexoMensagem> anexoMensagems) {
        for (AnexoMensagem anexoMensagem : anexoMensagems) {
            if (EntityCacheUtil.getResult(
                        AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
                        AnexoMensagemImpl.class, anexoMensagem.getPrimaryKey()) == null) {
                cacheResult(anexoMensagem);
            } else {
                anexoMensagem.resetOriginalValues();
            }
        }
    }

    /**
     * Clears the cache for all anexo mensagems.
     *
     * <p>
     * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
     * </p>
     */
    @Override
    public void clearCache() {
        if (_HIBERNATE_CACHE_USE_SECOND_LEVEL_CACHE) {
            CacheRegistryUtil.clear(AnexoMensagemImpl.class.getName());
        }

        EntityCacheUtil.clearCache(AnexoMensagemImpl.class.getName());

        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_ENTITY);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
    }

    /**
     * Clears the cache for the anexo mensagem.
     *
     * <p>
     * The {@link com.liferay.portal.kernel.dao.orm.EntityCache} and {@link com.liferay.portal.kernel.dao.orm.FinderCache} are both cleared by this method.
     * </p>
     */
    @Override
    public void clearCache(AnexoMensagem anexoMensagem) {
        EntityCacheUtil.removeResult(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemImpl.class, anexoMensagem.getPrimaryKey());

        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

        clearUniqueFindersCache(anexoMensagem);
    }

    @Override
    public void clearCache(List<AnexoMensagem> anexoMensagems) {
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);

        for (AnexoMensagem anexoMensagem : anexoMensagems) {
            EntityCacheUtil.removeResult(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
                AnexoMensagemImpl.class, anexoMensagem.getPrimaryKey());

            clearUniqueFindersCache(anexoMensagem);
        }
    }

    protected void cacheUniqueFindersCache(AnexoMensagem anexoMensagem) {
        if (anexoMensagem.isNew()) {
            Object[] args = new Object[] {
                    anexoMensagem.getUuid(), anexoMensagem.getGroupId()
                };

            FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_UUID_G, args,
                Long.valueOf(1));
            FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G, args,
                anexoMensagem);
        } else {
            AnexoMensagemModelImpl anexoMensagemModelImpl = (AnexoMensagemModelImpl) anexoMensagem;

            if ((anexoMensagemModelImpl.getColumnBitmask() &
                    FINDER_PATH_FETCH_BY_UUID_G.getColumnBitmask()) != 0) {
                Object[] args = new Object[] {
                        anexoMensagem.getUuid(), anexoMensagem.getGroupId()
                    };

                FinderCacheUtil.putResult(FINDER_PATH_COUNT_BY_UUID_G, args,
                    Long.valueOf(1));
                FinderCacheUtil.putResult(FINDER_PATH_FETCH_BY_UUID_G, args,
                    anexoMensagem);
            }
        }
    }

    protected void clearUniqueFindersCache(AnexoMensagem anexoMensagem) {
        AnexoMensagemModelImpl anexoMensagemModelImpl = (AnexoMensagemModelImpl) anexoMensagem;

        Object[] args = new Object[] {
                anexoMensagem.getUuid(), anexoMensagem.getGroupId()
            };

        FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID_G, args);
        FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_UUID_G, args);

        if ((anexoMensagemModelImpl.getColumnBitmask() &
                FINDER_PATH_FETCH_BY_UUID_G.getColumnBitmask()) != 0) {
            args = new Object[] {
                    anexoMensagemModelImpl.getOriginalUuid(),
                    anexoMensagemModelImpl.getOriginalGroupId()
                };

            FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID_G, args);
            FinderCacheUtil.removeResult(FINDER_PATH_FETCH_BY_UUID_G, args);
        }
    }

    /**
     * Creates a new anexo mensagem with the primary key. Does not add the anexo mensagem to the database.
     *
     * @param anexoMensagemId the primary key for the new anexo mensagem
     * @return the new anexo mensagem
     */
    @Override
    public AnexoMensagem create(long anexoMensagemId) {
        AnexoMensagem anexoMensagem = new AnexoMensagemImpl();

        anexoMensagem.setNew(true);
        anexoMensagem.setPrimaryKey(anexoMensagemId);

        String uuid = PortalUUIDUtil.generate();

        anexoMensagem.setUuid(uuid);

        return anexoMensagem;
    }

    /**
     * Removes the anexo mensagem with the primary key from the database. Also notifies the appropriate model listeners.
     *
     * @param anexoMensagemId the primary key of the anexo mensagem
     * @return the anexo mensagem that was removed
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem remove(long anexoMensagemId)
        throws NoSuchAnexoMensagemException, SystemException {
        return remove((Serializable) anexoMensagemId);
    }

    /**
     * Removes the anexo mensagem with the primary key from the database. Also notifies the appropriate model listeners.
     *
     * @param primaryKey the primary key of the anexo mensagem
     * @return the anexo mensagem that was removed
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem remove(Serializable primaryKey)
        throws NoSuchAnexoMensagemException, SystemException {
        Session session = null;

        try {
            session = openSession();

            AnexoMensagem anexoMensagem = (AnexoMensagem) session.get(AnexoMensagemImpl.class,
                    primaryKey);

            if (anexoMensagem == null) {
                if (_log.isWarnEnabled()) {
                    _log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
                }

                throw new NoSuchAnexoMensagemException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
                    primaryKey);
            }

            return remove(anexoMensagem);
        } catch (NoSuchAnexoMensagemException nsee) {
            throw nsee;
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }
    }

    @Override
    protected AnexoMensagem removeImpl(AnexoMensagem anexoMensagem)
        throws SystemException {
        anexoMensagem = toUnwrappedModel(anexoMensagem);

        Session session = null;

        try {
            session = openSession();

            if (!session.contains(anexoMensagem)) {
                anexoMensagem = (AnexoMensagem) session.get(AnexoMensagemImpl.class,
                        anexoMensagem.getPrimaryKeyObj());
            }

            if (anexoMensagem != null) {
                session.delete(anexoMensagem);
            }
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }

        if (anexoMensagem != null) {
            clearCache(anexoMensagem);
        }

        return anexoMensagem;
    }

    @Override
    public AnexoMensagem updateImpl(
        br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem anexoMensagem)
        throws SystemException {
        anexoMensagem = toUnwrappedModel(anexoMensagem);

        boolean isNew = anexoMensagem.isNew();

        AnexoMensagemModelImpl anexoMensagemModelImpl = (AnexoMensagemModelImpl) anexoMensagem;

        if (Validator.isNull(anexoMensagem.getUuid())) {
            String uuid = PortalUUIDUtil.generate();

            anexoMensagem.setUuid(uuid);
        }

        Session session = null;

        try {
            session = openSession();

            if (anexoMensagem.isNew()) {
                session.save(anexoMensagem);

                anexoMensagem.setNew(false);
            } else {
                session.merge(anexoMensagem);
            }
        } catch (Exception e) {
            throw processException(e);
        } finally {
            closeSession(session);
        }

        FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);

        if (isNew || !AnexoMensagemModelImpl.COLUMN_BITMASK_ENABLED) {
            FinderCacheUtil.clearCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
        }
        else {
            if ((anexoMensagemModelImpl.getColumnBitmask() &
                    FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID.getColumnBitmask()) != 0) {
                Object[] args = new Object[] {
                        anexoMensagemModelImpl.getOriginalUuid()
                    };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID,
                    args);

                args = new Object[] { anexoMensagemModelImpl.getUuid() };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID,
                    args);
            }

            if ((anexoMensagemModelImpl.getColumnBitmask() &
                    FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C.getColumnBitmask()) != 0) {
                Object[] args = new Object[] {
                        anexoMensagemModelImpl.getOriginalUuid(),
                        anexoMensagemModelImpl.getOriginalCompanyId()
                    };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID_C, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C,
                    args);

                args = new Object[] {
                        anexoMensagemModelImpl.getUuid(),
                        anexoMensagemModelImpl.getCompanyId()
                    };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_UUID_C, args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_UUID_C,
                    args);
            }

            if ((anexoMensagemModelImpl.getColumnBitmask() &
                    FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_MENSAGEMIDATIVO.getColumnBitmask()) != 0) {
                Object[] args = new Object[] {
                        anexoMensagemModelImpl.getOriginalMensagemId(),
                        anexoMensagemModelImpl.getOriginalAtivo()
                    };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_MENSAGEMIDATIVO,
                    args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_MENSAGEMIDATIVO,
                    args);

                args = new Object[] {
                        anexoMensagemModelImpl.getMensagemId(),
                        anexoMensagemModelImpl.getAtivo()
                    };

                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_BY_MENSAGEMIDATIVO,
                    args);
                FinderCacheUtil.removeResult(FINDER_PATH_WITHOUT_PAGINATION_FIND_BY_MENSAGEMIDATIVO,
                    args);
            }
        }

        EntityCacheUtil.putResult(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
            AnexoMensagemImpl.class, anexoMensagem.getPrimaryKey(),
            anexoMensagem);

        clearUniqueFindersCache(anexoMensagem);
        cacheUniqueFindersCache(anexoMensagem);

        return anexoMensagem;
    }

    protected AnexoMensagem toUnwrappedModel(AnexoMensagem anexoMensagem) {
        if (anexoMensagem instanceof AnexoMensagemImpl) {
            return anexoMensagem;
        }

        AnexoMensagemImpl anexoMensagemImpl = new AnexoMensagemImpl();

        anexoMensagemImpl.setNew(anexoMensagem.isNew());
        anexoMensagemImpl.setPrimaryKey(anexoMensagem.getPrimaryKey());

        anexoMensagemImpl.setUuid(anexoMensagem.getUuid());
        anexoMensagemImpl.setAnexoMensagemId(anexoMensagem.getAnexoMensagemId());
        anexoMensagemImpl.setMensagemId(anexoMensagem.getMensagemId());
        anexoMensagemImpl.setCompanyId(anexoMensagem.getCompanyId());
        anexoMensagemImpl.setGroupId(anexoMensagem.getGroupId());
        anexoMensagemImpl.setUserId(anexoMensagem.getUserId());
        anexoMensagemImpl.setDataCriacao(anexoMensagem.getDataCriacao());
        anexoMensagemImpl.setAnexoUrl(anexoMensagem.getAnexoUrl());
        anexoMensagemImpl.setFileName(anexoMensagem.getFileName());
        anexoMensagemImpl.setVersao(anexoMensagem.getVersao());
        anexoMensagemImpl.setContentType(anexoMensagem.getContentType());
        anexoMensagemImpl.setAtivo(anexoMensagem.isAtivo());
        anexoMensagemImpl.setAnexoFileEntryId(anexoMensagem.getAnexoFileEntryId());
        anexoMensagemImpl.setAnexoPath(anexoMensagem.getAnexoPath());

        return anexoMensagemImpl;
    }

    /**
     * Returns the anexo mensagem with the primary key or throws a {@link com.liferay.portal.NoSuchModelException} if it could not be found.
     *
     * @param primaryKey the primary key of the anexo mensagem
     * @return the anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem findByPrimaryKey(Serializable primaryKey)
        throws NoSuchAnexoMensagemException, SystemException {
        AnexoMensagem anexoMensagem = fetchByPrimaryKey(primaryKey);

        if (anexoMensagem == null) {
            if (_log.isWarnEnabled()) {
                _log.warn(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY + primaryKey);
            }

            throw new NoSuchAnexoMensagemException(_NO_SUCH_ENTITY_WITH_PRIMARY_KEY +
                primaryKey);
        }

        return anexoMensagem;
    }

    /**
     * Returns the anexo mensagem with the primary key or throws a {@link br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException} if it could not be found.
     *
     * @param anexoMensagemId the primary key of the anexo mensagem
     * @return the anexo mensagem
     * @throws br.mp.mprj.portal.portlet.gestaomensagens.service.NoSuchAnexoMensagemException if a anexo mensagem with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem findByPrimaryKey(long anexoMensagemId)
        throws NoSuchAnexoMensagemException, SystemException {
        return findByPrimaryKey((Serializable) anexoMensagemId);
    }

    /**
     * Returns the anexo mensagem with the primary key or returns <code>null</code> if it could not be found.
     *
     * @param primaryKey the primary key of the anexo mensagem
     * @return the anexo mensagem, or <code>null</code> if a anexo mensagem with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByPrimaryKey(Serializable primaryKey)
        throws SystemException {
        AnexoMensagem anexoMensagem = (AnexoMensagem) EntityCacheUtil.getResult(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
                AnexoMensagemImpl.class, primaryKey);

        if (anexoMensagem == _nullAnexoMensagem) {
            return null;
        }

        if (anexoMensagem == null) {
            Session session = null;

            try {
                session = openSession();

                anexoMensagem = (AnexoMensagem) session.get(AnexoMensagemImpl.class,
                        primaryKey);

                if (anexoMensagem != null) {
                    cacheResult(anexoMensagem);
                } else {
                    EntityCacheUtil.putResult(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
                        AnexoMensagemImpl.class, primaryKey, _nullAnexoMensagem);
                }
            } catch (Exception e) {
                EntityCacheUtil.removeResult(AnexoMensagemModelImpl.ENTITY_CACHE_ENABLED,
                    AnexoMensagemImpl.class, primaryKey);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return anexoMensagem;
    }

    /**
     * Returns the anexo mensagem with the primary key or returns <code>null</code> if it could not be found.
     *
     * @param anexoMensagemId the primary key of the anexo mensagem
     * @return the anexo mensagem, or <code>null</code> if a anexo mensagem with the primary key could not be found
     * @throws SystemException if a system exception occurred
     */
    @Override
    public AnexoMensagem fetchByPrimaryKey(long anexoMensagemId)
        throws SystemException {
        return fetchByPrimaryKey((Serializable) anexoMensagemId);
    }

    /**
     * Returns all the anexo mensagems.
     *
     * @return the anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findAll() throws SystemException {
        return findAll(QueryUtil.ALL_POS, QueryUtil.ALL_POS, null);
    }

    /**
     * Returns a range of all the anexo mensagems.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param start the lower bound of the range of anexo mensagems
     * @param end the upper bound of the range of anexo mensagems (not inclusive)
     * @return the range of anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findAll(int start, int end)
        throws SystemException {
        return findAll(start, end, null);
    }

    /**
     * Returns an ordered range of all the anexo mensagems.
     *
     * <p>
     * Useful when paginating results. Returns a maximum of <code>end - start</code> instances. <code>start</code> and <code>end</code> are not primary keys, they are indexes in the result set. Thus, <code>0</code> refers to the first result in the set. Setting both <code>start</code> and <code>end</code> to {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS} will return the full result set. If <code>orderByComparator</code> is specified, then the query will include the given ORDER BY logic. If <code>orderByComparator</code> is absent and pagination is required (<code>start</code> and <code>end</code> are not {@link com.liferay.portal.kernel.dao.orm.QueryUtil#ALL_POS}), then the query will include the default ORDER BY logic from {@link br.mp.mprj.portal.portlet.gestaomensagens.service.model.impl.AnexoMensagemModelImpl}. If both <code>orderByComparator</code> and pagination are absent, for performance reasons, the query will not have an ORDER BY clause and the returned result set will be sorted on by the primary key in an ascending order.
     * </p>
     *
     * @param start the lower bound of the range of anexo mensagems
     * @param end the upper bound of the range of anexo mensagems (not inclusive)
     * @param orderByComparator the comparator to order the results by (optionally <code>null</code>)
     * @return the ordered range of anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public List<AnexoMensagem> findAll(int start, int end,
        OrderByComparator orderByComparator) throws SystemException {
        boolean pagination = true;
        FinderPath finderPath = null;
        Object[] finderArgs = null;

        if ((start == QueryUtil.ALL_POS) && (end == QueryUtil.ALL_POS) &&
                (orderByComparator == null)) {
            pagination = false;
            finderPath = FINDER_PATH_WITHOUT_PAGINATION_FIND_ALL;
            finderArgs = FINDER_ARGS_EMPTY;
        } else {
            finderPath = FINDER_PATH_WITH_PAGINATION_FIND_ALL;
            finderArgs = new Object[] { start, end, orderByComparator };
        }

        List<AnexoMensagem> list = (List<AnexoMensagem>) FinderCacheUtil.getResult(finderPath,
                finderArgs, this);

        if (list == null) {
            StringBundler query = null;
            String sql = null;

            if (orderByComparator != null) {
                query = new StringBundler(2 +
                        (orderByComparator.getOrderByFields().length * 3));

                query.append(_SQL_SELECT_ANEXOMENSAGEM);

                appendOrderByComparator(query, _ORDER_BY_ENTITY_ALIAS,
                    orderByComparator);

                sql = query.toString();
            } else {
                sql = _SQL_SELECT_ANEXOMENSAGEM;

                if (pagination) {
                    sql = sql.concat(AnexoMensagemModelImpl.ORDER_BY_JPQL);
                }
            }

            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(sql);

                if (!pagination) {
                    list = (List<AnexoMensagem>) QueryUtil.list(q,
                            getDialect(), start, end, false);

                    Collections.sort(list);

                    list = new UnmodifiableList<AnexoMensagem>(list);
                } else {
                    list = (List<AnexoMensagem>) QueryUtil.list(q,
                            getDialect(), start, end);
                }

                cacheResult(list);

                FinderCacheUtil.putResult(finderPath, finderArgs, list);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(finderPath, finderArgs);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return list;
    }

    /**
     * Removes all the anexo mensagems from the database.
     *
     * @throws SystemException if a system exception occurred
     */
    @Override
    public void removeAll() throws SystemException {
        for (AnexoMensagem anexoMensagem : findAll()) {
            remove(anexoMensagem);
        }
    }

    /**
     * Returns the number of anexo mensagems.
     *
     * @return the number of anexo mensagems
     * @throws SystemException if a system exception occurred
     */
    @Override
    public int countAll() throws SystemException {
        Long count = (Long) FinderCacheUtil.getResult(FINDER_PATH_COUNT_ALL,
                FINDER_ARGS_EMPTY, this);

        if (count == null) {
            Session session = null;

            try {
                session = openSession();

                Query q = session.createQuery(_SQL_COUNT_ANEXOMENSAGEM);

                count = (Long) q.uniqueResult();

                FinderCacheUtil.putResult(FINDER_PATH_COUNT_ALL,
                    FINDER_ARGS_EMPTY, count);
            } catch (Exception e) {
                FinderCacheUtil.removeResult(FINDER_PATH_COUNT_ALL,
                    FINDER_ARGS_EMPTY);

                throw processException(e);
            } finally {
                closeSession(session);
            }
        }

        return count.intValue();
    }

    @Override
    protected Set<String> getBadColumnNames() {
        return _badColumnNames;
    }

    /**
     * Initializes the anexo mensagem persistence.
     */
    public void afterPropertiesSet() {
        String[] listenerClassNames = StringUtil.split(GetterUtil.getString(
                    com.liferay.util.service.ServiceProps.get(
                        "value.object.listener.br.mp.mprj.portal.portlet.gestaomensagens.service.model.AnexoMensagem")));

        if (listenerClassNames.length > 0) {
            try {
                List<ModelListener<AnexoMensagem>> listenersList = new ArrayList<ModelListener<AnexoMensagem>>();

                for (String listenerClassName : listenerClassNames) {
                    listenersList.add((ModelListener<AnexoMensagem>) InstanceFactory.newInstance(
                            getClassLoader(), listenerClassName));
                }

                listeners = listenersList.toArray(new ModelListener[listenersList.size()]);
            } catch (Exception e) {
                _log.error(e);
            }
        }
    }

    public void destroy() {
        EntityCacheUtil.removeCache(AnexoMensagemImpl.class.getName());
        FinderCacheUtil.removeCache(FINDER_CLASS_NAME_ENTITY);
        FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITH_PAGINATION);
        FinderCacheUtil.removeCache(FINDER_CLASS_NAME_LIST_WITHOUT_PAGINATION);
    }
}
